describe("Testing noinfopath-drupal Boostrap Carousel", function() {
	var $timeout, $httpBackend, $scope, $compile, $rootScope, noDataService, noDataServiceProviderRef, dataService,
		dataServiceModule = "noinfopath.drupal",
		expected = [
				{
				"nid": [{
					"value": "19"
				}],
				"uuid": [{
					"value": "c1cdb1b7-3c70-4726-9009-9e935ab35d34"
				}],
				"vid": [{
					"value": "19"
				}],
				"type": [{
					"target_id": "carousel_content"
				}],
				"langcode": [{
					"value": "en"
				}],
				"title": [{
					"value": "Slide-2"
				}],
				"uid": [{
					"target_id": "2",
					"url": "/user/2"
				}],
				"status": [{
					"value": "1"
				}],
				"created": [{
					"value": "1449595189"
				}],
				"changed": [{
					"value": "1449595230"
				}],
				"promote": [{
					"value": "0"
				}],
				"sticky": [{
					"value": "0"
				}],
				"revision_timestamp": [{
					"value": "1449595226"
				}],
				"revision_uid": [{
					"target_id": "2",
					"url": "/user/2"
				}],
				"revision_log": [],
				"revision_translation_affected": [{
					"value": "1"
				}],
				"default_langcode": [{
					"value": "1"
				}],
				"path": [],
				"field_images": [{
					"target_id": "14",
					"alt": "",
					"title": "",
					"width": "1459",
					"height": "411",
					"url": "images/feature-2.jpg"
				}]
			}, {
				"nid": [{
					"value": "18"
				}],
				"uuid": [{
					"value": "b319de11-8cc9-4115-8c00-b228d2ea8aca"
				}],
				"vid": [{
					"value": "18"
				}],
				"type": [{
					"target_id": "carousel_content"
				}],
				"langcode": [{
					"value": "en"
				}],
				"title": [{
					"value": "Slide-1"
				}],
				"uid": [{
					"target_id": "2",
					"url": "/user/2"
				}],
				"status": [{
					"value": "1"
				}],
				"created": [{
					"value": "1449550929"
				}],
				"changed": [{
					"value": "1449551550"
				}],
				"promote": [{
					"value": "0"
				}],
				"sticky": [{
					"value": "0"
				}],
				"revision_timestamp": [{
					"value": "1449551070"
				}],
				"revision_uid": [{
					"target_id": "2",
					"url": "/user/2"
				}],
				"revision_log": [],
				"revision_translation_affected": [{
					"value": "1"
				}],
				"default_langcode": [{
					"value": "1"
				}],
				"path": [],
				"field_images": [{
					"target_id": "13",
					"alt": "",
					"title": "",
					"width": "1459",
					"height": "411",
					"url": "images/feature-1.jpg"
				}]
			}, {
				"nid": [{
					"value": "19"
				}],
				"uuid": [{
					"value": "c1cdb1b7-3c70-4726-9009-9e935ab35d34"
				}],
				"vid": [{
					"value": "19"
				}],
				"type": [{
					"target_id": "carousel_content"
				}],
				"langcode": [{
					"value": "en"
				}],
				"title": [{
					"value": "Slide-3"
				}],
				"uid": [{
					"target_id": "2",
					"url": "/user/2"
				}],
				"status": [{
					"value": "1"
				}],
				"created": [{
					"value": "1449595189"
				}],
				"changed": [{
					"value": "1449595230"
				}],
				"promote": [{
					"value": "0"
				}],
				"sticky": [{
					"value": "0"
				}],
				"revision_timestamp": [{
					"value": "1449595226"
				}],
				"revision_uid": [{
					"target_id": "2",
					"url": "/user/2"
				}],
				"revision_log": [],
				"revision_translation_affected": [{
					"value": "1"
				}],
				"default_langcode": [{
					"value": "1"
				}],
				"path": [],
				"field_images": [{
					"target_id": "14",
					"alt": "",
					"title": "",
					"width": "1459",
					"height": "411",
					"url": "images/feature-3.jpg"
				}]
			}
		];

	beforeEach(function() {
		module('noinfopath.drupal.mocks');
		module('noinfopath.drupal');

		// module(dataServiceModule, ["noDataServiceProvider", function(noDataServiceProvider) {
		// 	noDataServiceProvider.setDefaultDataServiceModuleName(dataServiceModule);
		// }]);

		inject(function($injector) {
			$httpBackend = $injector.get("$httpBackend");
			$compile = $injector.get("$compile");
			$rootScope = $injector.get("$rootScope");
			$scope = $rootScope.$new();
			$timeout = $injector.get("$timeout");
			noDataService = $injector.get("noDataService");

			//noDataService.configure();
		});



	});

	function getCompiledElement() {

		var element = angular.element('<no-bootstrap-carousel data-provider="drupal"></no-bootstrap-carousel>');
		var compiledElement = $compile(element)($scope);
		$scope.$digest();
		return compiledElement;
	}

	describe("Testing noDataService", function() {
		it("GET should eventually data.", function(done) {

			// $httpBackend.when("OPTIONS", "http://foo/carouseldata")
			// 	.respond(200, {
			// 		"Access-Control-Allow-Origin": "http://localhost:9876",
			// 		"Access-Control-Allow-Methods": "POST, GET, OPTIONS"
			// 	});
			//
			// $httpBackend.when("GET", "http://localhost/carouseldata")
			// 	.respond(200, expected);

				noDataService.GET()
					.then(function(resp) {
						console.log(JSON.stringify(resp));
						expect(resp).toEqual(expected);
						done();
					})
					.catch(function(err) {
						console.error(err);
						done();
					});

				$httpBackend.flush();
		});

	});

	it("TODO: Need create a test the checks the rendering after the data is returned.");

	it("Test the directive", function() {
		//console.log(typeof directiveElem);
		var directiveElem = getCompiledElement(),
			result = directiveElem.html(),
			expected = '<div id="carousel1" class="carousel slide" data-ride="carousel"><ol class="carousel-indicators"></ol><div class="carousel-inner" role="listbox"></div><a class="left carousel-control" href="#carousel1" role="button" data-slide="prev"> <span class="glyphicon glyphicon-chevron-left" aria-hidden="true"></span> <span class="sr-only">Previous</span> </a><a class="right carousel-control" href="#carousel1" role="button" data-slide="next"> <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span> <span class="sr-only">Next</span> </a></div>';

		console.log("after: ", result);

		expect(result).toBeDefined();
		expect(result).toBe(expected);

	});
});
